Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package transform
  Definition Classes
    nsc
-  abstract class SpecializeTypes extends SubComponent with InfoTransform with TypingTransformers

  Specialize code on types.

  Specialize code on types.

  Make sure you've read the thesis:

  Iulian Dragos: Compiling Scala for Performance (chapter 4)

  There are some things worth noting, (possibly) not mentioned there: 0) Make sure you understand the meaning of various `SpecializedInfo` descriptors defined below.

  1) Specializing traits by introducing bridges in specialized methods of the specialized trait may introduce problems during mixin composition. Concretely, it may cause cyclic calls and result in a stack overflow. See ticket #4351. This was solved by introducing an `Abstract` specialized info descriptor. Instead of generating a bridge in the trait, an abstract method is generated.

  2) Specialized private members sometimes have to be switched to protected. In some cases, even this is not enough. Example:

      class A[@specialized T](protected val d: T) {
        def foo(that: A[T]) = that.d
      }

  Specialization will generate a specialized class and a specialized method:

      class A$mcI$sp(protected val d: Int) extends A[Int] {
        def foo(that: A[Int]) = foo$mcI$sp(that)
        def foo(that: A[Int]) = that.d
      }

  Above, `A$mcI$sp` cannot access `d`, so the method cannot be typechecked.

  Definition Classes
    transform
- Abstract
- Duplicator
- Forward
- Implementation
- ImplementationAdapter
- NormalizedMember
- Overload
- Phase
- SpecialOverload
- SpecialOverride
- SpecialSuperAccessor
- SpecializationDuplicator
- SpecializationPhase
- SpecializationTransformer
- SpecializedAccessor
- SpecializedInfo
- SpecializedInnerClass
- SpecializedSuperConstructorCallArgument
- StdPhase
- TypeEnv
- TypingTransformer
- UnifyError

o

scala.tools.nsc.transform.SpecializeTypes

# TypeEnv 

###

#### object TypeEnv

Source
  SpecializeTypes.scala

Linear Supertypes
AnyRef, Any
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. TypeEnv
2. AnyRef
3. Any

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
4.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
5.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
6.  final def eq(arg0: AnyRef): Boolean
   Definition Classes
     AnyRef
7.  def equals(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
8.  def finalize(): Unit
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( classOf[java.lang.Throwable] )
9.  def fromSpecialization(sym: Global.Symbol, args: List[Global.Type]): TypeEnv

   Return a new type environment binding specialized type parameters of sym to the given args.

   Return a new type environment binding specialized type parameters of sym to the given args. Expects the lists to have the same length.

10.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
11.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
12.  def includes(t1: TypeEnv, t2: TypeEnv): Boolean

    Does typeenv `t1` include `t2`? All type variables in `t1` are defined in `t2` and:

    Does typeenv `t1` include `t2`? All type variables in `t1` are defined in `t2` and:

    - are bound to the same type, or
    - are an AnyRef specialization and `t2` is bound to a subtype of AnyRef
13.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
14.  def isValid(env: TypeEnv, sym: Global.Symbol): Boolean

    Is the given environment a valid specialization for sym? It is valid if each binding is from a @specialized type parameter in sym (or its owner) to a type for which `sym` is specialized.

15.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
16.  final def notify(): Unit
    Definition Classes
      AnyRef
17.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
18.  def restrict(env: TypeEnv, tps: Set[Global.Symbol]): TypeEnv

    Reduce the given environment to contain mappings only for type variables in tps.

19.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
20.  def toString(): String
    Definition Classes
      AnyRef → Any
21.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
22.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
23.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from AnyRef

### Inherited from Any

### Ungrouped